
#include "bvideo.h"

#define MAP_BASE_BLOCK(p) SCREEN_BASE_BLOCK((p))
#define TILE_BASE_BLOCK(p) CHAR_BASE_BLOCK((p))

#define MAP_BASE_BLOCK_SUB(p) SCREEN_BASE_BLOCK_SUB((p))
#define TILE_BASE_BLOCK_SUB(p) CHAR_BASE_BLOCK_SUB((p))

// Always put the screen/map base *first* and the char/tile base *second*
// Since the map control register is only 5 bits, it cannot reach the
// latter half of a 128K bank (31*2K < 64K).  The solution is to map the
// screen/map low and put the tiles high.
const int mainMapBase = 0;
const int mainTileBase = 4;

const int subMapBase = 0;
const int subTileBase = 4;

void initVideoConsole(void) {
  lcdMainOnTop();
  vramSetBankA(VRAM_A_MAIN_BG);
  vramSetBankC(VRAM_C_SUB_BG);

  videoSetMode(MODE_0_2D | DISPLAY_BG0_ACTIVE);
  videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);

  BG0_CR = BG_MAP_BASE(mainMapBase) | BG_TILE_BASE(mainTileBase);
  BG_PALETTE[255] = RGB15(31, 31, 31);

  SUB_BG0_CR = BG_MAP_BASE(subMapBase) | BG_TILE_BASE(subTileBase);
  BG_PALETTE_SUB[255] = RGB15(31, 31, 31);

  consoleInitDefault((u16*)MAP_BASE_BLOCK(mainMapBase),
		     (u16*)TILE_BASE_BLOCK(mainTileBase),
		     16);

}
